# Guide to Jupyter-Notebooks

This repository contains a collection of [Jupyter-notebooks](https://jupyter.org/install) with instructions on how to work with the notebooks under different Python and R environments.

The Jupyter Notebook is an open-source web application that allows you to create and share documents that contain live computer code, equations, visualizations and narrative text. For more information about the jupyter notebooks you can visit [OGGM edu: how to notebooks](https://edu.oggm.org/en/latest/notebooks_howto.html). For an easier start up follow the tutorials in this repository. 

Some features of the notebook wont display in the preview of Gitlab. Therefore,
I recommend you download the repository, install `jupyter notebooks` following one of the options below and then visualise them locally.  


- Repository structure

```mermaid
graph LR;
    Repository --> R-notebooks ;
    Repository --> Python-notebooks;
		
    Python-notebooks --> id2["to-run-locally"];
    Python-notebooks --> id3["to-run-in-JASMIN"]
```

- Requirements for working with R-based Jupyter-notebooks:

  * [Conda](https://docs.conda.io/en/latest/) or [Miniconda](https://docs.conda.io/en/latest/miniconda.html) (jupyter-notebooks come with this installation).
  * [R and conda-r-environments installation](https://docs.anaconda.com/anaconda/user-guide/tasks/using-r-language/).
  For how to install these requirements and start a notebook with R see:
 
 1. [01_Installing_R_kernel.ipynb](https://git.noc.ac.uk/brecinosrivas/guide-to-jupyter-notebooks/-/blob/master/r-notebooks/01_Installing_R_kernel.ipynb)  
 
     
- Requirements for working with Python-based Jupyter-notebooks: 
  when coding in Python you have different options for your virtual environments. <br>
   
    Easy: <br>
    - Conda or Miniconda: Python come with this installation. 
    <br>
           
    Intermediate and Advanced, uses python pip tool to install: <br>
    - [Virtualenv](https://virtualenv.pypa.io/en/latest/installation.html#via-pip) and [virtualenvwrapper](https://virtualenvwrapper.readthedocs.io/en/latest/install.html). 
    - [pyenv](https://github.com/pyenv/pyenv) and [pyenv-virtualenv](https://github.com/pyenv/pyenv-virtualenv)
 
 All examples can be found below:
 
1. [01_Python_working_with_conda.ipynb](https://git.noc.ac.uk/brecinosrivas/guide-to-jupyter-notebooks/-/blob/master/python-notebooks/to_run_locally/01_Python_working_with_conda.ipynb)
2. [02_Python_working_with_virtualenv.ipynb](https://git.noc.ac.uk/brecinosrivas/guide-to-jupyter-notebooks/-/blob/master/python-notebooks/to_run_locally/02_Python_working_with_virtualenv.ipynb)
3. [03_Python_notebooks_in_JASMIN.ipynb](https://git.noc.ac.uk/brecinosrivas/guide-to-jupyter-notebooks/-/blob/master/python-notebooks/to_run_in_JASMIN/03_Python_notebooks_in_JASMIN.ipynb): JASMIN jupyter-lab works with virutalenv and pip.
  
See here [Tips](https://www.edureka.co/blog/wp-content/uploads/2018/10/Jupyter_Notebook_CheatSheet_Edureka.pdf) and [keyboard shorts](https://towardsdatascience.com/jypyter-notebook-shortcuts-bf0101a98330)

